<?php

/**
 * @file
 * Contains Drupal\chessboard\PiecePlacementInterface.
 */

namespace Drupal\chessboard;

/**
 * Defines a common interface for piece placement on the chessboard.
 */
Interface PiecePlacementInterface {

  /**
   * Gets the size of the piece placement value.
   *
   * @return int
   *   The size of the piece placement value, as an integer.
   */
  public function getSize();

  /**
   * Returns the piece code at the specified FEN piece placement indexes.
   *
   * @param int $fen_rank
   *   The FEN piece placement rank index for the piece code value.
   * @param int $fen_file
   *   The FEN piece placement file index for the piece code value.
   *
   * @return string
   *   The piece code value at the specified FEN piece placement indexes.
   *
   * @throws \RuntimeException
   */
  public function getPieceCode($fen_rank, $fen_file);

}
